#!/bin/sh
# $Id: dar-backup.sh 10 2008-08-17 12:58:00Z are $
# Needs curl, dar and mutt
#
# Backup Job

DATE=`date -I`

if [ -e /etc/dar-backup/dar-backup.conf ]; then
 . /etc/dar-backup/dar-backup.conf
 if [ -e /etc/dar-backup/dar-exclude.conf ]; then
  . /etc/dar-backup/dar-exclude.conf
 fi
elif [ -e /etc/backup-full.conf ]; then
 . /etc/backup-full.conf
else
 echo "No config file found for $0" >2
 exit 1
fi

if [ "x$CURLFS"!="x" ]; then
  if ! ( df -P | awk '$1 ~ /curlftpfs/ { print $6 }' | grep $CURLFS > /dev/null ); then
    curlftpfs -o user=$FTPUSER:$FTPPASS $FTPSERVER $CURLFS
  fi
fi

(
# Make sure FTPSERVER has a trailing / and starts with ftp://
if echo $FTPSERVER | egrep -q -v '^ftp://' > /dev/null ; then
  FTPSERVER="ftp://$FTPSERVER"
fi
if echo $FTPSERVER | egrep -q -v '/$' > /dev/null ; then
  FTPSERVER="$FTPSERVER/"
fi
# Make sure BACKUPDIR has no leading or trailing /
BACKUPDIR=`echo $BACKUPDIR | sed 's/^\///; s/\/$//'`

cd /$BACKUPDIR || exit 1
mkdir -p $DATE
cd /$BACKUPDIR/$DATE

find . -maxdepth 1 -name "$HOSTID-*" -mtime +1 | xargs -r rm
SLICE="-s 100M"
[ "$1" = "--no-slice" ] && SLICE=""
dar -c /$BACKUPDIR/$DATE/$HOSTID-$DATE \
    -R / $SLICE \
    $DAREXCLUDE \
    -y \
    -G /$BACKUPDIR/$DATE/$HOSTID-$DATE-catalog \
    -D \
    -aa \
    -Q
sync
FTPFAIL=0

#for i in $HOSTID-$DATE*; do
#  if [ $FTPFAIL -eq 0 ]; then
#    curl -sS -T $i --ftp-create-dirs -u $FTPUSER:$FTPPASS $FTPSERVER/$DATE/$i
#    FTPFAIL=$?
#  else
#    echo "Failed before transmitting $i"
#  fi
#  if [ $FTPFAIL -ne 0 ]; then
#    sleep 60
#    curl -sS -T $i --ftp-create-dirs -u $FTPUSER:$FTPPASS $FTPSERVER/$DATE/$i
#    FTPFAIL=$?
#  fi
#
#done


# Keep 3 Generations
ftpdeldate=`curl -sS -l -u $FTPUSER:$FTPPASS $FTPSERVER | sort -r | sed '/^\./d' | sed '1,3d; 5,$d'`
if [ "x$ftpdeldate" != "x" ]; then
 curl -sS -l -u $FTPUSER:$FTPPASS $FTPSERVER |
 sed '/^\./d' |
 sort |
 sed '/'$ftpdeldate'/,$d' |
 while read a; do
  curl -sS -l -u $FTPUSER:$FTPPASS $FTPSERVER$a/ |
  while read b; do
   curl -sS -T /etc/motd -Q "-DELE $a/$b" -u $FTPUSER:$FTPPASS -O $FTPSERVER/motd
  done;
  curl -sS -T /etc/motd -Q "-RMD /$a" -Q "-DELE motd" -u $FTPUSER:$FTPPASS -O $FTPSERVER/motd
 done
fi

) 2>&1 | mutt -s "Backup $HOSTID $DATE" $BACKUPMAIL
